<?php
//inicializa uma sessao
session_start();
//https://github.com/bramus/router
require_once "modelo/Router.php";
require_once "modelo/Usuario.php";

//Cria uma instância da classe Router
$router  = new Router();

// trata a rota: POST: /usuario, a rota cadastra um cliente.
$router->post('/usuario', function () {
  //recupera os dados enviados no corpo da requisição.
  $jsonRecebido = file_get_contents('php://input');
  $obj = json_decode($jsonRecebido);   //converte os dados em um objeto json.
  $u1 = new Usuario();   //cria uma instância de Usuario
  //faz o "set" dos dados dentro da classe.
  $u1->setNome($obj->nome);
  $u1->setEmail($obj->email);
  $u1->setSenha($obj->senha);
  //verifica se existe algum usuário com o mesmo email
  if ($u1->usuarioExiste() == false) {
    //executa o método create da classe Usuário
    //prepara o array resposta que será convertido em json
    $resposta['status'] = $u1->create();
    $resposta['msg'] = 'cadastrado com sucesso';
    $resposta['dados'] = $u1;
  } else {
    $resposta['status'] = false;
    $resposta['msg'] = 'já existe um usuário com o e-mail fornecido';
    $resposta['dados'] = $u1;
  }
  echo json_encode($resposta);
});

// trata a rota: GET /usuario, retorna todos os usuários
$router->get('/usuario', function () {
  $u1 = new Usuario();
  $resposta['status'] = true;
  $resposta['dados'] =  $u1->readAll();
  echo json_encode($resposta);
});

//trata a rota: GET /usuario/idUsuario, retorna usuário com id especifico
$router->get('/usuario/(\d+)', function ($v1) {
  $u1 = new Usuario();
  $u1->setIdUsuario($v1);
  $resposta['status'] = true;
  $resposta['dados'] =  $u1->read();
  echo json_encode($resposta);
});

//trata a rota: PUT /usuario/idUsuario
$router->put('/usuario/(\d+)', function ($v1) {
  $u1 = new Usuario();
  if ($u1->estaLogado() == true) {
    $jsonRecebido = file_get_contents('php://input');
    $obj = json_decode($jsonRecebido);
    $u1->setIdUsuario($v1);
    $u1->setNome($obj->nome);
    $u1->setEmail($obj->email);
    $u1->setSenha($obj->senha);
    $resposta['status'] = $u1->update();
    $resposta['msg'] = "Atualizado com sucesso";
    $resposta['dados'] = $u1;
    echo json_encode($resposta);
  } else {
    $resposta['status'] = false;
    $resposta['msg'] = 'Usuário não logado';
    echo json_encode($resposta);
  }
});

////trata a rota: DELETE /usuario/idUsuario
$router->delete('/usuario/(\d+)', function ($v1) {
  $u1 = new Usuario();
  if ($u1->estaLogado() == true) {
    $u1->setIdUsuario($v1);
    $resposta['status'] = $u1->delete();
    $resposta['msg'] = "excluído com sucesso";
    echo json_encode($resposta);
  } else {
    $resposta['status'] = false;
    $resposta['msg'] = 'Usuário não logado';
    echo json_encode($resposta);
  }
});

//trata a rota POST: / login
//verifica se usuário e senha estão corretos
//cria uma sessão para o usuário
$router->post('/login', function () {
  $jsonRecebido = file_get_contents('php://input');
  $obj = json_decode($jsonRecebido);
  $u1 = new Usuario();
  $u1->setEmail($obj->email);
  $u1->setSenha($obj->senha);
  $resposta = array();
  if ($u1->verificarUsuarioSenha() == true) {
    $resposta['status'] = 'true';
    $resposta['msg'] = "Login efetuado com sucesso";
  } else {
    $u1->logout();
    $resposta['status'] = false;
    $resposta['msg'] = "Usuario ou senha invalidos";
  }
  echo json_encode($resposta);
});

//trata a rota /logout
//destroi a sessão
$router->get('/logout', function () {

  $u1 = new Usuario();
  $resposta = array();

  $u1->logout();

  $resposta['status'] = true;
  $resposta['msg'] = "sessão encerrada";
  echo json_encode($resposta);
});
$router->run();
